local fennel = require("fennel")
local function shellout(command)
  local f = io.popen(command)
  local stdout = f:read("*all")
  return (f:close() and stdout)
end
local function execute(cmd)
  local _0_ = os.execute(cmd)
  if (_0_ == 0) then
    return true
  elseif (_0_ == true) then
    return true
  end
end
local function string__3ec_hex_literal(characters)
  local hex = {}
  for character in characters:gmatch(".") do
    table.insert(hex, ("0x%02x"):format(string.byte(character)))
  end
  return table.concat(hex, ", ")
end
local c_shim = "#ifdef __cplusplus\nextern \"C\" {\n#endif\n#include <lauxlib.h>\n#include <lua.h>\n#include <lualib.h>\n#ifdef __cplusplus\n}\n#endif\n#include <signal.h>\n#include <stdio.h>\n#include <stdlib.h>\n#include <string.h>\n\n#if LUA_VERSION_NUM == 501\n  #define LUA_OK 0\n#endif\n\n/* Copied from lua.c */\n\nstatic lua_State *globalL = NULL;\n\nstatic void lstop (lua_State *L, lua_Debug *ar) {\n  (void)ar;  /* unused arg. */\n  lua_sethook(L, NULL, 0, 0);  /* reset hook */\n  luaL_error(L, \"interrupted!\");\n}\n\nstatic void laction (int i) {\n  signal(i, SIG_DFL); /* if another SIGINT happens, terminate process */\n  lua_sethook(globalL, lstop, LUA_MASKCALL | LUA_MASKRET | LUA_MASKCOUNT, 1);\n}\n\nstatic void createargtable (lua_State *L, char **argv, int argc, int script) {\n  int i, narg;\n  if (script == argc) script = 0;  /* no script name? */\n  narg = argc - (script + 1);  /* number of positive indices */\n  lua_createtable(L, narg, script + 1);\n  for (i = 0; i < argc; i++) {\n    lua_pushstring(L, argv[i]);\n    lua_rawseti(L, -2, i - script);\n  }\n  lua_setglobal(L, \"arg\");\n}\n\nstatic int msghandler (lua_State *L) {\n  const char *msg = lua_tostring(L, 1);\n  if (msg == NULL) {  /* is error object not a string? */\n    if (luaL_callmeta(L, 1, \"__tostring\") &&  /* does it have a metamethod */\n        lua_type(L, -1) == LUA_TSTRING)  /* that produces a string? */\n      return 1;  /* that is the message */\n    else\n      msg = lua_pushfstring(L, \"(error object is a %%s value)\",\n                            luaL_typename(L, 1));\n  }\n  /* Call debug.traceback() instead of luaL_traceback() for Lua 5.1 compat. */\n  lua_getglobal(L, \"debug\");\n  lua_getfield(L, -1, \"traceback\");\n  /* debug */\n  lua_remove(L, -2);\n  lua_pushstring(L, msg);\n  /* original msg */\n  lua_remove(L, -3);\n  lua_pushinteger(L, 2);  /* skip this function and traceback */\n  lua_call(L, 2, 1); /* call debug.traceback */\n  return 1;  /* return the traceback */\n}\n\nstatic int docall (lua_State *L, int narg, int nres) {\n  int status;\n  int base = lua_gettop(L) - narg;  /* function index */\n  lua_pushcfunction(L, msghandler);  /* push message handler */\n  lua_insert(L, base);  /* put it under function and args */\n  globalL = L;  /* to be available to 'laction' */\n  signal(SIGINT, laction);  /* set C-signal handler */\n  status = lua_pcall(L, narg, nres, base);\n  signal(SIGINT, SIG_DFL); /* reset C-signal handler */\n  lua_remove(L, base);  /* remove message handler from the stack */\n  return status;\n}\n\nint main(int argc, char *argv[]) {\n lua_State *L = luaL_newstate();\n luaL_openlibs(L);\n createargtable(L, argv, argc, 0);\n\n static const unsigned char lua_loader_program[] = {\n%s\n};\n  if(luaL_loadbuffer(L, (const char*)lua_loader_program,\n                     sizeof(lua_loader_program), \"%s\") != LUA_OK) {\n    fprintf(stderr, \"luaL_loadbuffer: %%s\\n\", lua_tostring(L, -1));\n    lua_close(L);\n    return 1;\n  }\n\n  /* lua_bundle */\n  lua_newtable(L);\n  static const unsigned char lua_require_1[] = {\n  %s\n  };\n  lua_pushlstring(L, (const char*)lua_require_1, sizeof(lua_require_1));\n  lua_setfield(L, -2, \"%s\");\n\n%s\n\n  if (docall(L, 1, LUA_MULTRET)) {\n    const char *errmsg = lua_tostring(L, 1);\n    if (errmsg) {\n      fprintf(stderr, \"%%s\\n\", errmsg);\n    }\n    lua_close(L);\n    return 1;\n  }\n  lua_close(L);\n  return 0;\n}"
local function compile_fennel(filename, options)
  local f
  if (filename == "-") then
    f = io.stdin
  else
    f = assert(io.open(filename, "rb"))
  end
  local lua_code = fennel["compile-string"](f:read("*a"), options)
  f:close()
  return lua_code
end
local function native_loader(native)
  local nm = (os.getenv("NM") or "nm")
  local out = {"  /* native libraries */"}
  for _, path in ipairs(native) do
    for open in shellout((nm .. " " .. path)):gmatch("[^dDt] _?luaopen_([%a%p%d]+)") do
      table.insert(out, ("  int luaopen_%s(lua_State *L);"):format(open))
      table.insert(out, ("  lua_pushcfunction(L, luaopen_%s);"):format(open))
      table.insert(out, ("  lua_setfield(L, -2, \"%s\");\n"):format((open:sub(1, 1) .. open:sub(2):gsub("_", "."))))
    end
  end
  return table.concat(out, "\n")
end
local function fennel__3ec(filename, native, options)
  local basename = filename:gsub("(.*[\\/])(.*)", "%2")
  local basename_noextension = (basename:match("(.+)%.") or basename)
  local dotpath = filename:gsub("^%.%/", ""):gsub("[\\/]", ".")
  local dotpath_noextension = (dotpath:match("(.+)%.") or dotpath)
  local fennel_loader
  local _0_
  do
    _0_ = "(do (local bundle_0_ ...) (fn loader_0_ [name_0_] (match (or (. bundle_0_ name_0_) (. bundle_0_ (.. name_0_ \".init\"))) (mod_0_ ? (= \"function\" (type mod_0_))) mod_0_ (mod_0_ ? (= \"string\" (type mod_0_))) (assert (if (= _VERSION \"Lua 5.1\") (loadstring mod_0_ name_0_) (load mod_0_ name_0_))) nil (values nil (: \"\n\\tmodule '%%s' not found in fennel bundle\" \"format\" name_0_)))) (table.insert (or package.loaders package.searchers) 2 loader_0_) ((assert (loader_0_ \"%s\")) ((or unpack table.unpack) arg)))"
  end
  fennel_loader = _0_:format(dotpath_noextension)
  local lua_loader = fennel["compile-string"](fennel_loader)
  return c_shim:format(string__3ec_hex_literal(lua_loader), basename_noextension, string__3ec_hex_literal(compile_fennel(filename, options)), dotpath_noextension, native_loader(native))
end
local function write_c(filename, native, options)
  local out_filename = (filename .. "_binary.c")
  local f = assert(io.open(out_filename, "w+"))
  f:write(fennel__3ec(filename, native, options))
  f:close()
  return out_filename
end
local function compile_binary(lua_c_path, executable_name, static_lua, lua_include_dir, native)
  local cc = (os.getenv("CC") or "cc")
  local rdynamic, bin_extension, ldl_3f = nil, nil, nil
  if shellout((cc .. " -dumpmachine")):match("mingw") then
    rdynamic, bin_extension, ldl_3f = "", ".exe", false
  else
    rdynamic, bin_extension, ldl_3f = "-rdynamic", "", true
  end
  local compile_command
  local _1_
  if ldl_3f then
    _1_ = "-ldl"
  else
    _1_ = ""
  end
  compile_command = {cc, "-Os", lua_c_path, table.concat(native, " "), static_lua, rdynamic, "-lm", _1_, "-o", (executable_name .. bin_extension), "-I", lua_include_dir, os.getenv("CC_OPTS")}
  if os.getenv("FENNEL_DEBUG") then
    print("Compiling with", table.concat(compile_command, " "))
  end
  if not execute(table.concat(compile_command, " ")) then
    print("failed:", table.concat(compile_command, " "))
    os.exit(1)
  end
  if not os.getenv("FENNEL_DEBUG") then
    os.remove(lua_c_path)
  end
  return os.exit(0)
end
local function native_path_3f(path)
  local _0_ = path:match("%.(%a+)$")
  if (_0_ == "a") then
    return path
  elseif (_0_ == "o") then
    return path
  elseif (_0_ == "so") then
    return path
  elseif (_0_ == "dylib") then
    return path
  else
    local _ = _0_
    return false
  end
end
local function extract_native_args(args)
  local native = {libraries = {}, modules = {}}
  for i = #args, 1, -1 do
    if ("--native-module" == args[i]) then
      local path = assert(native_path_3f(table.remove(args, (i + 1))))
      table.insert(native.modules, 1, path)
      table.insert(native.libraries, 1, path)
      table.remove(args, i)
    end
    if ("--native-library" == args[i]) then
      table.insert(native.libraries, 1, assert(native_path_3f(table.remove(args, (i + 1)))))
      table.remove(args, i)
    end
  end
  if (0 < #args) then
    print(table.concat(args, " "))
    error(("Unknown args: " .. table.concat(args, " ")))
  end
  return native
end
local function compile(filename, executable_name, static_lua, lua_include_dir, options, args)
  local _let_0_ = extract_native_args(args)
  local libraries = _let_0_["libraries"]
  local modules = _let_0_["modules"]
  return compile_binary(write_c(filename, modules, options), executable_name, static_lua, lua_include_dir, libraries)
end
local help = ("\nUsage: %s --compile-binary FILE OUT STATIC_LUA_LIB LUA_INCLUDE_DIR\n\nCompile a binary from your Fennel program.\n\nRequires a C compiler, a copy of liblua, and Lua's dev headers. Implies\nthe --require-as-include option.\n\n  FILE: the Fennel source being compiled.\n  OUT: the name of the executable to generate\n  STATIC_LUA_LIB: the path to the Lua library to use in the executable\n  LUA_INCLUDE_DIR: the path to the directory of Lua C header files\n\nFor example, on a Debian system, to compile a file called program.fnl using\nLua 5.3, you would use this:\n\n    $ %s --compile-binary program.fnl program \\\n        /usr/lib/x86_64-linux-gnu/liblua5.3.a /usr/include/lua5.3\n\nThe program will be compiled to Lua, then compiled to C, then compiled to\nmachine code. You can set the CC environment variable to change the compiler\nused (default: cc) or set CC_OPTS to pass in compiler options. For example\nset CC_OPTS=-static to generate a binary with static linking.\n\nTo include C libraries that contain Lua modules, add --native-module path/to.so,\nand to include C libraries without modules, use --native-library path/to.so.\nThese options are unstable, barely tested, and even more likely to break.\n\nThis method is currently limited to programs do not transitively require Lua\nmodules. Requiring a Lua module directly will work, but requiring a Lua module\nwhich requires another will fail."):format(arg[0], arg[0])
return {compile = compile, help = help}
